open GtkSignal
open Gobject
open Data
let set = set
let get = get
let param = param
open GtkActionProps

class virtual action_props = object (self)
  method private virtual obj : _ obj
  method set_hide_if_empty = set Action.P.hide_if_empty self#obj
  method set_is_important = set Action.P.is_important self#obj
  method set_label = set Action.P.label self#obj
  method set_sensitive = set Action.P.sensitive self#obj
  method set_short_label = set Action.P.short_label self#obj
  method set_stock_id = set Action.P.stock_id self#obj
  method set_tooltip = set Action.P.tooltip self#obj
  method set_visible = set Action.P.visible self#obj
  method set_visible_horizontal = set Action.P.visible_horizontal self#obj
  method set_visible_vertical = set Action.P.visible_vertical self#obj
  method hide_if_empty = get Action.P.hide_if_empty self#obj
  method is_important = get Action.P.is_important self#obj
  method label = get Action.P.label self#obj
  method name = get Action.P.name self#obj
  method sensitive = get Action.P.sensitive self#obj
  method short_label = get Action.P.short_label self#obj
  method stock_id = get Action.P.stock_id self#obj
  method tooltip = get Action.P.tooltip self#obj
  method visible = get Action.P.visible self#obj
  method visible_horizontal = get Action.P.visible_horizontal self#obj
  method visible_vertical = get Action.P.visible_vertical self#obj
end

class virtual action_sigs = object (self)
  method private virtual connect :
    'b. ('a,'b) GtkSignal.t -> callback:'b -> GtkSignal.id
  method activate = self#connect Action.S.activate
end

class virtual toggle_action_props = object (self)
  method private virtual obj : _ obj
  method set_draw_as_radio = set ToggleAction.P.draw_as_radio self#obj
  method draw_as_radio = get ToggleAction.P.draw_as_radio self#obj
end

class virtual toggle_action_sigs = object (self)
  method private virtual connect :
    'b. ('a,'b) GtkSignal.t -> callback:'b -> GtkSignal.id
  method toggled = self#connect ToggleAction.S.toggled
end

class virtual radio_action_props = object (self)
  method private virtual obj : _ obj
  method set_group = set RadioAction.P.group self#obj
  method set_value = set RadioAction.P.value self#obj
  method value = get RadioAction.P.value self#obj
end

class virtual ui_manager_props = object (self)
  method private virtual obj : _ obj
  method set_add_tearoffs = set UIManager.P.add_tearoffs self#obj
  method add_tearoffs = get UIManager.P.add_tearoffs self#obj
  method ui = get UIManager.P.ui self#obj
end

class virtual ui_manager_sigs = object (self)
  method private virtual connect :
    'b. ('a,'b) GtkSignal.t -> callback:'b -> GtkSignal.id
  method actions_changed = self#connect UIManager.S.actions_changed
  method add_widget = self#connect
    {UIManager.S.add_widget with marshaller = fun f ->
     marshal1 GObj.conv_widget "GtkUIManager::add_widget" f}
end

class virtual action_group_props = object (self)
  method private virtual obj : _ obj
  method set_sensitive = set ActionGroup.P.sensitive self#obj
  method set_visible = set ActionGroup.P.visible self#obj
  method name = get ActionGroup.P.name self#obj
  method sensitive = get ActionGroup.P.sensitive self#obj
  method visible = get ActionGroup.P.visible self#obj
end

