open GtkSignal
open Gobject
open Data
let set = set
let get = get
let param = param

open GtkBaseProps

open GtkBaseProps

class virtual container_props = object (self)
  method private virtual obj : _ obj
  method set_border_width = set Container.P.border_width self#obj
  method set_resize_mode = set Container.P.resize_mode self#obj
  method border_width = get Container.P.border_width self#obj
  method resize_mode = get Container.P.resize_mode self#obj
end

class virtual container_sigs = object (self)
  method private virtual connect :
    'b. ('a,'b) GtkSignal.t -> callback:'b -> GtkSignal.id
  method add = self#connect
    {Container.S.add with marshaller = fun f ->
     marshal1 GObj.conv_widget "GtkContainer::add" f}
  method remove = self#connect
    {Container.S.remove with marshaller = fun f ->
     marshal1 GObj.conv_widget "GtkContainer::remove" f}
end

class virtual item_sigs = object (self)
  method private virtual connect :
    'b. ('a,'b) GtkSignal.t -> callback:'b -> GtkSignal.id
  method select = self#connect Item.S.select
  method deselect = self#connect Item.S.deselect
  method toggle = self#connect Item.S.toggle
end

class virtual window_props = object (self)
  method private virtual obj : _ obj
  method set_title = set Window.P.title self#obj
  method set_allow_grow = set Window.P.allow_grow self#obj
  method set_allow_shrink = set Window.P.allow_shrink self#obj
  method set_default_height = set Window.P.default_height self#obj
  method set_default_width = set Window.P.default_width self#obj
  method set_destroy_with_parent = set Window.P.destroy_with_parent self#obj
  method set_icon = set Window.P.icon self#obj
  method set_modal = set Window.P.modal self#obj
  method set_resizable = set Window.P.resizable self#obj
  method set_screen = set Window.P.screen self#obj
  method set_skip_pager_hint = set Window.P.skip_pager_hint self#obj
  method set_skip_taskbar_hint = set Window.P.skip_taskbar_hint self#obj
  method set_type_hint = set Window.P.type_hint self#obj
  method set_position = set Window.P.window_position self#obj
  method title = get Window.P.title self#obj
  method allow_grow = get Window.P.allow_grow self#obj
  method allow_shrink = get Window.P.allow_shrink self#obj
  method default_height = get Window.P.default_height self#obj
  method default_width = get Window.P.default_width self#obj
  method destroy_with_parent = get Window.P.destroy_with_parent self#obj
  method has_toplevel_focus = get Window.P.has_toplevel_focus self#obj
  method icon = get Window.P.icon self#obj
  method is_active = get Window.P.is_active self#obj
  method modal = get Window.P.modal self#obj
  method resizable = get Window.P.resizable self#obj
  method screen = get Window.P.screen self#obj
  method skip_pager_hint = get Window.P.skip_pager_hint self#obj
  method skip_taskbar_hint = get Window.P.skip_taskbar_hint self#obj
  method kind = get Window.P.kind self#obj
  method type_hint = get Window.P.type_hint self#obj
  method position = get Window.P.window_position self#obj
end

class virtual dialog_props = object (self)
  method private virtual obj : _ obj
  method set_has_separator = set Dialog.P.has_separator self#obj
  method has_separator = get Dialog.P.has_separator self#obj
end

class virtual file_selection_props = object (self)
  method private virtual obj : _ obj
  method set_filename = set FileSelection.P.filename self#obj
  method set_select_multiple = set FileSelection.P.select_multiple self#obj
  method set_show_fileops = set FileSelection.P.show_fileops self#obj
  method filename = get FileSelection.P.filename self#obj
  method select_multiple = get FileSelection.P.select_multiple self#obj
  method show_fileops = get FileSelection.P.show_fileops self#obj
end

class virtual message_dialog_props = object (self)
  method private virtual obj : _ obj
  method set_message_type = set MessageDialog.P.message_type self#obj
  method message_type = get MessageDialog.P.message_type self#obj
end

class virtual about_dialog_props = object (self)
  method private virtual obj : _ obj
  method set_comments = set AboutDialog.P.comments self#obj
  method set_copyright = set AboutDialog.P.copyright self#obj
  method set_license = set AboutDialog.P.license self#obj
  method set_logo = set AboutDialog.P.logo self#obj
  method set_logo_icon_name = set AboutDialog.P.logo_icon_name self#obj
  method set_name = set AboutDialog.P.name self#obj
  method set_translator_credits =
    set AboutDialog.P.translator_credits self#obj
  method set_version = set AboutDialog.P.version self#obj
  method set_website = set AboutDialog.P.website self#obj
  method set_website_label = set AboutDialog.P.website_label self#obj
  method comments = get AboutDialog.P.comments self#obj
  method copyright = get AboutDialog.P.copyright self#obj
  method license = get AboutDialog.P.license self#obj
  method logo = get AboutDialog.P.logo self#obj
  method logo_icon_name = get AboutDialog.P.logo_icon_name self#obj
  method name = get AboutDialog.P.name self#obj
  method translator_credits = get AboutDialog.P.translator_credits self#obj
  method version = get AboutDialog.P.version self#obj
  method website = get AboutDialog.P.website self#obj
  method website_label = get AboutDialog.P.website_label self#obj
end

class virtual plug_sigs = object (self)
  method private virtual connect :
    'b. ('a,'b) GtkSignal.t -> callback:'b -> GtkSignal.id
  method embedded = self#connect Plug.S.embedded
end

class virtual socket_sigs = object (self)
  method private virtual connect :
    'b. ('a,'b) GtkSignal.t -> callback:'b -> GtkSignal.id
  method plug_added = self#connect Socket.S.plug_added
  method plug_removed = self#connect Socket.S.plug_removed
end

