open GtkSignal
open Gobject
open Data
let set = set
let get = get
let param = param
open GtkMiscProps

class virtual misc_props = object (self)
  method private virtual obj : _ obj
  method set_xalign = set Misc.P.xalign self#obj
  method set_yalign = set Misc.P.yalign self#obj
  method set_xpad = set Misc.P.xpad self#obj
  method set_ypad = set Misc.P.ypad self#obj
  method xalign = get Misc.P.xalign self#obj
  method yalign = get Misc.P.yalign self#obj
  method xpad = get Misc.P.xpad self#obj
  method ypad = get Misc.P.ypad self#obj
end

class virtual label_props = object (self)
  method private virtual obj : _ obj
  method set_label = set Label.P.label self#obj
  method set_use_markup = set Label.P.use_markup self#obj
  method set_use_underline = set Label.P.use_underline self#obj
  method set_mnemonic_widget =
    set {Label.P.mnemonic_widget with conv=GObj.conv_widget_option} self#obj
  method set_justify = set Label.P.justify self#obj
  method set_line_wrap = set Label.P.wrap self#obj
  method set_pattern = set Label.P.pattern self#obj
  method set_selectable = set Label.P.selectable self#obj
  method set_angle = set Label.P.angle self#obj
  method set_ellipsize = set Label.P.ellipsize self#obj
  method set_max_width_chars = set Label.P.max_width_chars self#obj
  method set_single_line_mode = set Label.P.single_line_mode self#obj
  method set_width_chars = set Label.P.width_chars self#obj
  method label = get Label.P.label self#obj
  method use_markup = get Label.P.use_markup self#obj
  method use_underline = get Label.P.use_underline self#obj
  method mnemonic_keyval = get Label.P.mnemonic_keyval self#obj
  method mnemonic_widget =
    get {Label.P.mnemonic_widget with conv=GObj.conv_widget_option} self#obj
  method justify = get Label.P.justify self#obj
  method line_wrap = get Label.P.wrap self#obj
  method selectable = get Label.P.selectable self#obj
  method cursor_position = get Label.P.cursor_position self#obj
  method selection_bound = get Label.P.selection_bound self#obj
  method angle = get Label.P.angle self#obj
  method ellipsize = get Label.P.ellipsize self#obj
  method max_width_chars = get Label.P.max_width_chars self#obj
  method single_line_mode = get Label.P.single_line_mode self#obj
  method width_chars = get Label.P.width_chars self#obj
end

class virtual tips_query_props = object (self)
  method private virtual obj : _ obj
  method set_caller =
    set {TipsQuery.P.caller with conv=GObj.conv_widget_option} self#obj
  method set_emit_always = set TipsQuery.P.emit_always self#obj
  method set_label_inactive = set TipsQuery.P.label_inactive self#obj
  method set_label_no_tip = set TipsQuery.P.label_no_tip self#obj
  method caller =
    get {TipsQuery.P.caller with conv=GObj.conv_widget_option} self#obj
  method emit_always = get TipsQuery.P.emit_always self#obj
  method label_inactive = get TipsQuery.P.label_inactive self#obj
  method label_no_tip = get TipsQuery.P.label_no_tip self#obj
end

class virtual tips_query_sigs = object (self)
  method private virtual connect :
    'b. ('a,'b) GtkSignal.t -> callback:'b -> GtkSignal.id
  method start_query = self#connect TipsQuery.S.start_query
  method stop_query = self#connect TipsQuery.S.stop_query
  method widget_entered = self#connect
    {TipsQuery.S.widget_entered with marshaller = fun f ->
     marshal3 GObj.conv_widget_option string string
       "GtkTipsQuery::widget_entered"
       (fun x1 x2 x3 -> f x1 ~text:x2 ~privat:x3)}
  method widget_selected = self#connect
    {TipsQuery.S.widget_selected with marshaller = fun f ->
     marshal4_ret ~ret:boolean GObj.conv_widget_option string string
       (unsafe_pointer : GdkEvent.Button.t data_conv)
       "GtkTipsQuery::widget_selected"
       (fun x1 x2 x3 -> f x1 ~text:x2 ~privat:x3)}
end

class virtual arrow_props = object (self)
  method private virtual obj : _ obj
  method set_kind = set Arrow.P.arrow_type self#obj
  method set_shadow = set Arrow.P.shadow_type self#obj
  method kind = get Arrow.P.arrow_type self#obj
  method shadow = get Arrow.P.shadow_type self#obj
end

class virtual image_props = object (self)
  method private virtual obj : _ obj
  method set_file = set Image.P.file self#obj
  method set_image = set Image.P.image self#obj
  method set_pixbuf = set Image.P.pixbuf self#obj
  method set_mask = set Image.P.mask self#obj
  method set_stock = set Image.P.stock self#obj
  method set_icon_set = set Image.P.icon_set self#obj
  method set_icon_size = set Image.P.icon_size self#obj
  method image = get Image.P.image self#obj
  method pixbuf = get Image.P.pixbuf self#obj
  method mask = get Image.P.mask self#obj
  method stock = get Image.P.stock self#obj
  method icon_set = get Image.P.icon_set self#obj
  method icon_size = get Image.P.icon_size self#obj
  method storage_type = get Image.P.storage_type self#obj
end

class virtual color_selection_props = object (self)
  method private virtual obj : _ obj
  method set_alpha = set ColorSelection.P.current_alpha self#obj
  method set_color = set ColorSelection.P.current_color self#obj
  method set_has_opacity_control =
    set ColorSelection.P.has_opacity_control self#obj
  method set_has_palette = set ColorSelection.P.has_palette self#obj
  method alpha = get ColorSelection.P.current_alpha self#obj
  method color = get ColorSelection.P.current_color self#obj
  method has_opacity_control =
    get ColorSelection.P.has_opacity_control self#obj
  method has_palette = get ColorSelection.P.has_palette self#obj
end

class virtual font_selection_props = object (self)
  method private virtual obj : _ obj
  method set_font_name = set FontSelection.P.font_name self#obj
  method set_preview_text = set FontSelection.P.preview_text self#obj
  method font_name = get FontSelection.P.font_name self#obj
  method preview_text = get FontSelection.P.preview_text self#obj
end

class virtual calendar_props = object (self)
  method private virtual obj : _ obj
  method set_day = set Calendar.P.day self#obj
  method set_month = set Calendar.P.month self#obj
  method set_year = set Calendar.P.year self#obj
  method day = get Calendar.P.day self#obj
  method month = get Calendar.P.month self#obj
  method year = get Calendar.P.year self#obj
end

class virtual calendar_sigs = object (self)
  method private virtual connect :
    'b. ('a,'b) GtkSignal.t -> callback:'b -> GtkSignal.id
  method day_selected = self#connect Calendar.S.day_selected
  method day_selected_double_click =
    self#connect Calendar.S.day_selected_double_click
  method month_changed = self#connect Calendar.S.month_changed
  method next_month = self#connect Calendar.S.next_month
  method next_year = self#connect Calendar.S.next_year
  method prev_month = self#connect Calendar.S.prev_month
  method prev_year = self#connect Calendar.S.prev_year
end

