open GtkSignal
open Gobject
open Data
let set = set
let get = get
let param = param
open GtkRangeProps

class virtual ruler_props = object (self)
  method private virtual obj : _ obj
  method set_lower = set Ruler.P.lower self#obj
  method set_upper = set Ruler.P.upper self#obj
  method set_max_size = set Ruler.P.max_size self#obj
  method set_position = set Ruler.P.position self#obj
  method lower = get Ruler.P.lower self#obj
  method upper = get Ruler.P.upper self#obj
  method max_size = get Ruler.P.max_size self#obj
  method position = get Ruler.P.position self#obj
end

class virtual range_props = object (self)
  method private virtual obj : _ obj
  method set_adjustment =
    set {Range.P.adjustment with conv=GData.conv_adjustment} self#obj
  method set_inverted = set Range.P.inverted self#obj
  method set_update_policy = set Range.P.update_policy self#obj
  method adjustment =
    get {Range.P.adjustment with conv=GData.conv_adjustment} self#obj
  method inverted = get Range.P.inverted self#obj
  method update_policy = get Range.P.update_policy self#obj
end

class virtual range_sigs = object (self)
  method private virtual connect :
    'b. ('a,'b) GtkSignal.t -> callback:'b -> GtkSignal.id
  method adjust_bounds = self#connect Range.S.adjust_bounds
  method move_slider = self#connect Range.S.move_slider
  method value_changed = self#connect Range.S.value_changed
end

class virtual scale_props = object (self)
  method private virtual obj : _ obj
  method set_digits = set Scale.P.digits self#obj
  method set_draw_value = set Scale.P.draw_value self#obj
  method set_value_pos = set Scale.P.value_pos self#obj
  method digits = get Scale.P.digits self#obj
  method draw_value = get Scale.P.draw_value self#obj
  method value_pos = get Scale.P.value_pos self#obj
end

class virtual progress_bar_props = object (self)
  method private virtual obj : _ obj
  method set_adjustment =
    set {ProgressBar.P.adjustment with conv=GData.conv_adjustment} self#obj
  method set_orientation = set ProgressBar.P.orientation self#obj
  method set_fraction = set ProgressBar.P.fraction self#obj
  method set_pulse_step = set ProgressBar.P.pulse_step self#obj
  method set_text = set ProgressBar.P.text self#obj
  method set_ellipsize = set ProgressBar.P.ellipsize self#obj
  method adjustment =
    get {ProgressBar.P.adjustment with conv=GData.conv_adjustment} self#obj
  method orientation = get ProgressBar.P.orientation self#obj
  method fraction = get ProgressBar.P.fraction self#obj
  method pulse_step = get ProgressBar.P.pulse_step self#obj
  method text = get ProgressBar.P.text self#obj
  method ellipsize = get ProgressBar.P.ellipsize self#obj
end

